<template>
	<div>
		<div style="position: fixed; width: 100%;">
			<CommonHeader
				:setOrden="true"
				:showMenu="true"
				:showBackButton="true"
				:title="$t('taxInformation')"
			></CommonHeader>
		</div>
		<div class="content">
			<p class="title">{{ $t('taxInformation') }}</p>
			<p class="text">{{ $t('taxForm') }}</p>
			<form class="form-crear">
				<div class="form-group">
					<label
						>{{ $t('nameComplete') }}:
						<span v-if="formErrors.name" class="error">{{ $t('required') }}</span></label
					>
					<input v-model="formData.name" :placeholder="$t('contactName')" />
				</div>
				<div class="form-group">
					<label
						>{{ $t('correo') }}:
						<span v-if="formErrors.email" class="error">{{ $t('required') }}</span></label
					>
					<input v-model="formData.email" :placeholder="$t('correoPlaceholder')" />
				</div>
				<div class="form-group">
					<label
						>{{ $t('telephone') }}:
						<span v-if="formErrors.phoneNumber" class="error">{{ $t('required') }}</span>
					</label>
					<input v-model="formData.phoneNumber" :placeholder="$t('telephonePlaceholder')" />
				</div>
				<div class="form-group">
					<label
						>RFC: <span v-if="formErrors.rfc" class="error">{{ $t('required') }}</span></label
					>
					<input v-model="formData.rfc" :placeholder="$t('writeRFC')" />
				</div>
				<div class="form-group">
					<label
						>{{ $t('businessName') }}:
						<span v-if="formErrors.businessName" class="error">{{ $t('required') }}</span></label
					>
					<input v-model="formData.businessName" :placeholder="$t('writeBusinessName')" />
				</div>
				<div class="form-group">
					<label
						>{{ $t('street') }}:
						<span v-if="formErrors.address" class="error">{{ $t('required') }}</span></label
					>
					<input v-model="formData.address" :placeholder="$t('streetPH')" />
				</div>
				<div class="form-group">
					<label
						>{{ $t('numExt') }}:
						<span v-if="formErrors.extNumber" class="error">{{ $t('required') }}</span></label
					>
					<input v-model="formData.extNumber" :placeholder="$t('numIntPH')" />
				</div>
				<div class="form-group">
					<label
						>{{ $t('numInt') }}:
						<span v-if="formErrors.intNumber" class="error">{{ $t('required') }}</span></label
					>
					<input v-model="formData.intNumber" :placeholder="$t('numIntPH')" />
				</div>
				<div class="form-group">
					<label
						>{{ $t('cpp') }}:
						<span v-if="formErrors.postalCode" class="error">{{ $t('required') }}</span></label
					>
					<input v-model="formData.postalCode" :placeholder="$t('cppPH')" />
				</div>
				<div class="form-group">
					<label
						>{{ $t('state') }}:
						<span v-if="formErrors.state" class="error">{{ $t('required') }}</span></label
					>
					<select name="state" v-model="formData.state">
						<option selected :label="$t('selectState')"></option>
						<option v-for="item in state" :key="item" :value="item">{{ item }}</option>
					</select>
				</div>
				<div class="form-group">
					<label
						>{{ $t('locality') }}:
						<span v-if="formErrors.locality" class="error">{{ $t('required') }}</span></label
					>
					<input v-model="formData.locality" :placeholder="$t('locality')" />
				</div>
				<div class="form-group">
					<label
						>{{ $t('suburb') }}:
						<span v-if="formErrors.region" class="error">{{ $t('required') }}</span></label
					>
					<input v-model="formData.region" :placeholder="$t('colonyName')" />
				</div>
			</form>
			<div class="acciones">
				<!-- <button @click="share()" class="compartir">Compartir</button> -->
				<AjaxButton class="final-button" :loading="loading" :text="$t('save')" @click="sendForm()"></AjaxButton>
			</div>
		</div>
	</div>
</template>
<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import CommonHeader from '@/components/CommonHeader.vue'
import AjaxButton from '@/components/AjaxButton.vue'
import InvoiceData from '@/models/InvoiceData'
import UserService from '@/services/UserService'

@Component({
	components: {
		CommonHeader,
		AjaxButton
	}
})
export default class InvoiceRegister extends Vue {
	user = this.$store.state.user
	loading = false
	invoice: InvoiceData | null = null
	state = [
		'AGUASCALIENTES',
		'BAJA CALIFORNIA',
		'BAJA CALIFORNIA SUR',
		'CAMPECHE',
		'CHIAPAS',
		'CHIHUAHUA',
		'CIUDAD DE MEXICO',
		'COAHUILA',
		'COLIMA',
		'DURANGO',
		'ESTADO DE MEXICO',
		'GUANAJUATO',
		'GUERRERO',
		'HIDALGO',
		'JALISCO',
		'SAN LUIS POTOSI',
		'MICHOACAN',
		'MORELOS',
		'NAYARIT',
		'NUEVO LEON',
		'OAXACA',
		'PUEBLA',
		'QUERETARO',
		'QUINTANA ROO',
		'SINALOA',
		'SONORA',
		'TABASCO',
		'TAMAULIPAS',
		'TLAXCALA',
		'VERACRUZ',
		'YUCATAN',
		'ZACATECAS'
	]

	formData = {
		name: '',
		email: '',
		phoneNumber: '',
		rfc: '',
		businessName: '',
		address: '',
		extNumber: '',
		intNumber: '',
		postalCode: '',
		state: '',
		locality: '',
		region: ''
	}

	formErrors = {
		name: false,
		email: false,
		phoneNumber: false,
		rfc: false,
		businessName: false,
		address: false,
		extNumber: false,
		intNumber: false,
		postalCode: false,
		state: false,
		locality: false,
		region: false
	}

	async created() {
		this.invoice = await UserService.getInvoiceData(this.user.id)
		if (this.invoice) {
			this.formData.name = this.invoice.name
			this.formData.email = this.invoice.email
			this.formData.phoneNumber = this.invoice.phoneNumber
			this.formData.rfc = this.invoice.rfc
			this.formData.businessName = this.invoice.businessName
			this.formData.address = this.invoice.address
			this.formData.extNumber = this.invoice.extNumber
			this.formData.intNumber = this.invoice.intNumber
			this.formData.postalCode = this.invoice.postalCode
			this.formData.state = this.invoice.state
			this.formData.locality = this.invoice.locality
			this.formData.region = this.invoice.region
		} else {
			this.formData.name = this.user.name
			this.formData.email = this.user.email
			this.formData.phoneNumber = this.user.phone
		}
	}

	async sendForm() {
		if (this.invoice) {
			if (!this.validForm()) return
			await UserService.updateInvoicing(this.invoice, this.user.id)
		} else {
			if (!this.validForm()) return
			const invoiceOrder: InvoiceData = {
				id: '',
				idUser: this.user.id,
				name: this.formData.name,
				email: this.formData.email,
				phoneNumber: this.formData.phoneNumber,
				rfc: this.formData.rfc,
				businessName: this.formData.businessName,
				address: this.formData.address,
				extNumber: this.formData.extNumber,
				intNumber: this.formData.intNumber,
				postalCode: this.formData.postalCode,
				state: this.formData.state,
				locality: this.formData.locality,
				region: this.formData.region
			}
			await UserService.saveInvoincing(invoiceOrder, this.user.id)
		}
		this.$router.push('/profile')
	}

	validForm(): boolean {
		this.formErrors = {
			name: false,
			email: false,
			phoneNumber: false,
			rfc: false,
			businessName: false,
			address: false,
			extNumber: false,
			intNumber: false,
			postalCode: false,
			state: false,
			locality: false,
			region: false
		}
		if (!this.formData.name) this.formErrors.name = true
		if (!this.formData.email || !/^\S+@.+\.\S+$/.test(this.formData.email)) this.formErrors.email = true
		if (!this.formData.phoneNumber || !/^[0-9]{10}$/.test(this.formData.phoneNumber))
			this.formErrors.phoneNumber = true
		if (!this.formData.rfc) this.formErrors.rfc = true
		if (!this.formData.businessName) this.formErrors.businessName = true
		if (!this.formData.address) this.formErrors.address = true
		if (!this.formData.extNumber) this.formErrors.extNumber = true
		if (!this.formData.intNumber) this.formErrors.intNumber = true
		if (!this.formData.postalCode) this.formErrors.postalCode = true
		if (!this.formData.state) this.formErrors.state = true
		if (!this.formData.locality) this.formErrors.locality = true
		if (!this.formData.region) this.formErrors.region = true
		for (const error of Object.values(this.formErrors)) {
			if (error == true) {
				return false
			}
		}
		return true
	}
}
</script>
<style lang="scss" scoped>
p {
	margin: 0px;
}
.content {
	padding: 1em;
	padding-top: 9vh;

	.title {
		color: rgba(254, 202, 56, 1);
		font-weight: bold;
		font-size: 2em;
	}
	.text {
		line-height: 21, 09px;
		font-size: 1.2em;
		color: rgba(0, 0, 0, 1);
		margin: 0.5em 0;
	}
}
.form-crear {
	label {
		font-size: 1em;
		color: #000;
		margin-bottom: 0.4em;
	}
	.form-group {
		display: grid;
		margin: 1em 0;

		input,
		select {
			border-radius: 7px;
			border: 0.5px solid rgba(192, 192, 192, 1);
			padding: 0.8em 0.8em 0.8em 10px;
		}
		select {
			background-color: white;
			color: rgba(117, 112, 112, 1);
		}
		input::-webkit-input-placeholder {
			color: rgba(117, 112, 112, 1);
			font-size: 1.2em;
		}
		.error {
			font-size: 12px;
			color: red;
			margin: auto;
		}
	}
}
.acciones {
	margin: 1em 0;
	display: flex;
	.final-button {
		font-weight: 500;
		font-size: 1.1em;
		color: white;
	}
	.compartir {
		font-weight: 500;
		font-size: 1.1em;
		color: white;
		background: rgba(25, 118, 210, 1);
		border: 1px solid rgba(25, 118, 210, 1);
		border-radius: 6px;
		margin-right: 10px;
	}
}
</style>
